import sys
sys.path.append('DepthHelper')

import cv2
import torch
from core.raft import RAFT
from enum import Enum , unique , auto
from core.utils.utils import InputPadder
import collections
from torchvision import transforms

@unique
class InputType(Enum) :
    CuttedInput = auto()
    WithoutBackGroundFull = auto() #处理后使用全图
    WithoutBackGroundCut = auto() #处理后需要将原图切开
    WithROIFullPic = auto()

class DepthHelper:
    def __init__(self ) -> None:
        return

    def loadModel(self , path: str , args ,DEVICE:str) :

        # model = torch.nn.DataParallel(RAFT(args))
        # model.load_state_dict(torch.load(args.model))

        # model = model.module 

        self.m_model = RAFT(args)  #这里可能会有问题
        state_dict = torch.load(path,map_location=torch.device(DEVICE))
        self.device = DEVICE
        new_state_dict = collections.OrderedDict()
        for k, v in state_dict.items():
            name = k[7:]  # remove "module."
            new_state_dict[name] = v
        self.m_model.load_state_dict(new_state_dict) #这里load_state_dict显示缺了数据
        # self.m_model = self.m_model.module
        self.m_model.to(DEVICE)
        self.m_model.eval()


    #色彩在detect中选择
    def Estim(self , src1 : cv2.Mat , src2: cv2.Mat, valid_iters:int, calculateType: int) :
        with torch.no_grad():
            img1 = torch.from_numpy(src1).permute(2,0,1).float().to(self.device)
            img2 = torch.from_numpy(src2).permute(2,0,1).float().to(self.device)
            img1 = img1.unsqueeze(0)
            img2 = img2.unsqueeze(0)
            padder = InputPadder(img1.shape)
            img1 , img2 = padder.pad(img1 , img2)

            _ , flow_up = self.m_model(img1 , img2 , iters = valid_iters ,test_mode=True)
            flow_up = padder.unpad(flow_up)
        # flow_up = flow_up.detach().numpy().squeeze().permute(1,2,0)
        return flow_up
        # if calculateType == InputType.WithoutBackGroundCut.value : 
        #     flow_up.cpu().numpy().squeeze()
            
        #     #裁剪flow_up
        #     return None
        # if calculateType == InputType.WithROIFullPic.value : 
        #     #裁剪flow_up
        #     return None
        # intensor = -flow_up.cpu().detach().numpy().squeeze() #torch转opencvMat
        # # transforms.ToPILImage()
        # return intensor

        
