'''
骨架提取
'''
import cv2
import numpy as np
import math
 
#由于我们经过之前的代码转换到了二值图，所以这里不需要转换
img = cv2.imread('1.png', cv2.IMREAD_GRAYSCALE)
size = img.shape
height = size[0]
width = size[1]

img_depth = cv2.imread('3_resize_gray.jpeg', cv2.IMREAD_GRAYSCALE )
dst = img.copy()
print(img_depth.shape)
skeleton = np.zeros(dst.shape, np.uint8)
open_dst = np.zeros(dst.shape, np.uint8)
while (True):
    if np.sum(dst) == 0:
        break
    kernel = cv2.getStructuringElement(cv2.MORPH_CROSS, (7, 7))
    # dst = cv2.erode(dst, kernel, None, None, 1)
    cv2.erode(dst, kernel, dst , (-1,-1) , 1)
    
    cv2.morphologyEx(dst, cv2.MORPH_OPEN, kernel,open_dst )
    result = dst - open_dst
    skeleton = skeleton + result
    # cv2.waitKey(0)

global minPointX
minPointX = height-1
global minPointY
minPointY = width-1
global maxPointX 
global maxPointY 
maxPointX = 0 
maxPointY = 0
# i = int(0)
# j = int(0)
for i in range(0,height):
    for j in range(0,width):
        tColor = skeleton[i , j] 
        if (tColor == 255 and (i<minPointX or j <minPointY )) :
            minPointX = i
            minPointY = j
        if( tColor == 255 and (i > maxPointX or j > maxPointY)) :
            maxPointX = i
            maxPointY = j
#计算深度

dA = img_depth[minPointX , minPointY]
dB = img_depth[maxPointX , maxPointY]
fX = float(3010.1)
tan = fX*(dB-dA)/((dA-minPointX+width/2)*dB -(dB-maxPointX+93.*2)*dA)
angle = math.atan(tan) /3.14 *180 
print("angle is :  "  , angle)
        
cv2.namedWindow("result",0)
cv2.resizeWindow("result",480,1260)
cv2.imshow('result', skeleton)
cv2.imwrite("4-output2.png",skeleton)
 
# cv2.waitKey(0)
# cv2.destroyAllWindows()